<?php

namespace App\controleur;

class UtilisateurControleur
{
    public function __construct()
    {
        global $twig;
        if (!isset($_REQUEST["action"])) {
            $action = NULL;
        } else {
            $action = \App\config\Validation::nettoyerString($_REQUEST["action"]);
        }
        switch ($action) {
            case NULL:
            case "accueil":
                $this->accueil();
                break;
            case "inscription_success":
                $this->inscription_success();
                break;
            case "connection":
                $this->connection();
                break;
            case "inscription":
                $this->inscription();

                break;
            case "consulterProfilLimite":
                $this->consulterProfilLimite();
                break;
            default:
                $dVueErreur[] ="Action non autorisée";
                echo $twig->render("erreur.html",['dVueErreur' => $dVueErreur]);

        }
    }

    protected function connection()
    {
        global $twig;
        $dVueErreur = []; // Tableau pour stocker les erreurs, le cas échéant
        $userModel = new \App\modele\UtilisateurModele();

        if (isset($_POST['email'], $_POST['password'])) {
            $email = \App\config\Validation::nettoyerString($_POST['email']);
            $motDePasse = \App\config\Validation::nettoyerString($_POST['password']);
            $utilisateur = $userModel->connection($email, $motDePasse);
            if ($utilisateur instanceof \App\metier\Alumni) {
                $_SESSION['utilisateur'] = $utilisateur;
                header('Location: index.php?action=accueil');
                exit();
            } else {
                $dVueErreur[] = "L'adresse email ou le mot de passe est incorrect.";
            }
        }
        echo $twig->render('connection.html', ['dVueErreur' => $dVueErreur]);
    }

    protected function inscription()
    {
        global $twig;
        $dVueErreur = []; // Tableau pour stocker les erreurs, le cas échéant
        $userModel = new \App\modele\UtilisateurModele();

        if (isset($_POST['firstname'],$_POST['name'], $_POST['email'], $_POST['password'])) {
            $nom = \App\config\Validation::nettoyerString($_POST['name']);
            $prenom = \App\config\Validation::nettoyerString($_POST['firstname']);
            $email = \App\config\Validation::nettoyerString($_POST['email']);
            $motDePasse = \App\config\Validation::nettoyerString($_POST['password']);
            $hash = password_hash($motDePasse, PASSWORD_DEFAULT);

            // verification que l'email est valide et unique :
            if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
                $dVueErreur[] = "L'adresse email n'est pas valide ou est déjà utilisée.";
            } else {
                $utilisateur = $userModel->getUtilisateurByEmail($email);
                if ($utilisateur instanceof \App\metier\Alumni) {
                    $dVueErreur[] = "L'adresse email est déjà utilisée.";
                }
            }
            $nouvelUtilisateur = $userModel->inscription($prenom,$nom,$email, $hash);

            if ($nouvelUtilisateur instanceof \App\metier\Alumni) {
                header('Location: index.php?action=inscription_success');
                exit();
            } else {
                $dVueErreur[] = "L'inscription a échoué, veuillez réessayer.";
            }
        }
        echo $twig->render('inscription.html', ['dVueErreur' => $dVueErreur]);
    }

    protected function accueil()
    {
        global $twig;
        // Ajout d'un var_dump pour déboguer
        if (isset($_SESSION['utilisateur']) && $_SESSION['utilisateur'] instanceof \App\metier\Alumni) {
            $prenom = $_SESSION['utilisateur']->getPrenom();
            $nom = $_SESSION['utilisateur']->getNom();
        }
        else{
            $prenom =  null;
            $nom = null;
        }
        //aller sur la page d'accueil avec le nom et prenom de l'utilisateur
        echo $twig->render('accueil.html', ['prenom' => $prenom, 'nom' => $nom]);
    }

    protected function inscription_success()
    {
        global $twig;
        echo $twig->render('inscription_success.html');
    }
    protected function consulterProfilLimite()
    {
        //TODO
    }

}